"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n  display: block;\n  margin: 1em auto;\n  width: 100%;\n  height: 6em;\n\n  circle {\n    fill: none;\n    stroke-width: 20;\n    transform: translate(100px, 100px) rotate(-89.9deg);\n    transition: stroke-dashoffset 0.3s linear;\n  }\n\n  .arc-background {\n    stroke: ", ";\n  }\n\n  .arc {\n    stroke: ", ";\n    stroke-linecap: ", ";\n  }\n\n  text {\n    fill: ", ";\n    font-size: 50px;\n    font-weight: 600;\n    text-anchor: middle;\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var Svg = _styledComponents["default"].svg(_templateObject(), function (props) {
  return props.arcBackgroundColor;
}, function (props) {
  return props.arcColor;
}, function (props) {
  return props.rounded ? "round" : "inherit";
}, function (props) {
  return props.textColor;
});

function ProgressArc(_ref) {
  var value = _ref.value,
      max = _ref.max,
      className = _ref.className,
      unit = _ref.unit,
      arcColor = _ref.arcColor,
      arcBackgroundColor = _ref.arcBackgroundColor,
      textColor = _ref.textColor,
      textVisible = _ref.textVisible,
      radius = _ref.radius,
      rounded = _ref.rounded,
      dominantBaseline = _ref.dominantBaseline;
  var p = 2 * radius * Math.PI;
  return /*#__PURE__*/_react["default"].createElement(Svg, {
    className: className,
    arcColor: arcColor,
    arcBackgroundColor: arcBackgroundColor,
    textColor: textColor,
    rounded: rounded,
    viewBox: "0 0 200 200"
  }, /*#__PURE__*/_react["default"].createElement("circle", {
    className: "arc-background",
    r: radius
  }), /*#__PURE__*/_react["default"].createElement("circle", {
    className: "arc",
    r: radius,
    strokeDashoffset: (max - value) / max * p,
    strokeDasharray: p
  }), textVisible && /*#__PURE__*/_react["default"].createElement("text", {
    x: "100",
    y: "100",
    dominantBaseline: dominantBaseline
  }, "".concat(value).concat(unit)));
}

ProgressArc.propTypes = {
  value: _propTypes["default"].number.isRequired,
  max: _propTypes["default"].number,
  unit: _propTypes["default"].string,
  arcColor: _propTypes["default"].string,
  arcBackgroundColor: _propTypes["default"].string,
  textColor: _propTypes["default"].string,
  textVisible: _propTypes["default"].bool,
  radius: _propTypes["default"].number,
  rounded: _propTypes["default"].bool
};
ProgressArc.defaultProps = {
  value: 0,
  max: 100,
  unit: "%",
  arcColor: "#818a91",
  arcBackgroundColor: "#eceeef",
  textColor: "#818a91",
  textVisible: true,
  radius: 90,
  rounded: false,
  dominantBaseline: "middle"
};
var _default = ProgressArc;
exports["default"] = _default;